import vrml.Event;
import vrml.field.ConstSFTime;
import vrml.field.SFBool;
import vrml.field.SFTime;
import vrml.node.Script;

public class AutomaticDoor extends Script {
   SFBool turnOnLight;
   SFTime openDoor;
   SFTime closeDoor;
   boolean onOff = false;

   public void initialize() {
      this.turnOnLight = (SFBool)((Script)this).getEventOut("turnOnLight");
      this.openDoor = (SFTime)((Script)this).getEventOut("openDoor");
      this.closeDoor = (SFTime)((Script)this).getEventOut("closeDoor");
   }

   public void processEvent(Event var1) {
      if (var1.getName().equals("touched")) {
         this.onOff = !this.onOff;
         this.turnOnLight.setValue(this.onOff);
      } else {
         if (var1.getName().equals("enterArea")) {
            if (this.onOff) {
               this.openDoor.setValue(((ConstSFTime)var1.getValue()).getValue());
               return;
            }
         } else if (var1.getName().equals("exitArea")) {
            this.closeDoor.setValue(((ConstSFTime)var1.getValue()).getValue());
         }

      }
   }
}
