import java.util.Random;
import vrml.Event;
import vrml.field.ConstSFTime;
import vrml.field.MFRotation;
import vrml.field.SFTime;
import vrml.node.Script;

public class RollingCD extends Script {
   MFRotation setCDrollingAxis;
   SFTime setCDstartTime;
   float[] rollingParameters = new float[20];
   Random randomNumGenerator = new Random();

   public void initialize() {
      this.setCDrollingAxis = (MFRotation)((Script)this).getEventOut("setCDrollingAxis");
      this.setCDstartTime = (SFTime)((Script)this).getEventOut("setCDstartTime");
      this.rollingParameters[3] = 0.0F;
      this.rollingParameters[7] = 1.57F;
      this.rollingParameters[11] = 3.14F;
      this.rollingParameters[15] = 4.71F;
      this.rollingParameters[19] = 6.28F;
   }

   public void processEvent(Event var1) {
      if (var1.getName().equals("touched")) {
         this.setRollingParameters();
         this.setCDstartTime.setValue(((ConstSFTime)var1.getValue()).getValue());
      }

   }

   void setRollingParameters() {
      double var1 = this.randomNumGenerator.nextDouble() * Math.PI * (double)2.0F;
      double var3 = Math.cos(var1);
      double var5 = Math.sin(var1);

      for(int var7 = 0; var7 < 5; ++var7) {
         this.rollingParameters[var7 * 4] = (float)var3;
         this.rollingParameters[var7 * 4 + 1] = (float)var5;
         this.rollingParameters[var7 * 4 + 2] = 0.0F;
      }

      this.setCDrollingAxis.setValue(20, this.rollingParameters);
   }
}
